﻿using System;
using System.Collections.Generic;
using XMailAdminProxy;
using System.Text.RegularExpressions;
using System.IO;


public class ControlAccounts
{
    public struct ControlAccount
    {
        public string Name;
        public string Password;
    }

    public static string[] extractCtrlAccounts(string line)
    {
        string[] parts = null;
        
        Regex re = new Regex("\\s+");
        parts = re.Split(line);
        for (int i = 0; i < parts.Length; i++) parts[i] = parts[i].Trim(new char[] { '"' });
        return parts;
    }

    public static void AddControlAccount(ControlAccount cAccount)
    {
        List<ControlAccount> cAccounts = GetControlAccounts();
        cAccounts.Add(cAccount);
        SetControlAccounts(cAccounts);
    }

    public static void SetControlAccountPassword(string Name, string Password)
    {
        List<ControlAccount> cAccountsNew = new List<ControlAccount>();
        ControlAccount cAccount = new ControlAccount();
        List<ControlAccount> cAccounts = GetControlAccounts();

        foreach (ControlAccount ca in cAccounts)
        {
            cAccount = ca;
            if (ca.Name == Name)
                cAccount.Password = Password;
            cAccountsNew.Add(cAccount);
        }
        SetControlAccounts(cAccountsNew);
    }

    public static void DeleteControlAccount(ControlAccount cAccount)
    {
        List<ControlAccount> cAccounts = GetControlAccounts();
        List<ControlAccount> cAccountsNew = new List<ControlAccount>();

        foreach (ControlAccount ca in cAccounts)
            if (ca.Name != cAccount.Name)
                cAccountsNew.Add(ca);

        SetControlAccounts(cAccountsNew);
    }

    public static List<ControlAccount> GetControlAccounts()
    {
        List<ControlAccount> cAccounts = new List<ControlAccount>();
        try
        {
            XMLayer xm = Utils.CreateXMLayer();
            string raw = "";
            string line;
            xm.Login();
            raw = xm.GetCtrlAccounts();
            xm.Logout();
            using (StringReader sr = new StringReader(raw))
            {
                string[] data;
                ControlAccount cAccount = new ControlAccount();
                while ((line = sr.ReadLine()) != null)
                {
                    line = line.Trim();
                    if (line == ".") break;
                    data = extractCtrlAccounts(line);
                    cAccount.Name = data[0];
                    cAccount.Password = Utils.DecryptPassword(data[1]);
                    cAccounts.Add(cAccount);
                }
            }
        }
        catch (Exception)
        {
            throw;
        }
        return cAccounts;
    }

    public static bool IsControlAccountExist(string Name)
    {
        List<ControlAccount> cAccounts = new List<ControlAccount>();
        bool result = false;
        try
        {
            cAccounts = ControlAccounts.GetControlAccounts();
            foreach (ControlAccount ca in cAccounts)
            {
                if (ca.Name != Name) continue;
                result = true;
                break;
            }
        }
        catch (Exception)
        {
            throw;
        }
        return result;
    }
    
    public static void SetControlAccounts(List<ControlAccount> cAccounts)
    {
        try
        {
            XMLayer xm = Utils.CreateXMLayer();
            string param = "";

            foreach (ControlAccount ca in cAccounts)
            {
                param += '\"' + ca.Name + '\"' + '\t' + '\"' + Utils.EncryptPassword(ca.Password) + '\"' + "\r\n";
            }
            xm.Login();
            xm.SetCtrlAccounts(param);
            xm.Logout();
        }
        catch (Exception)
        {
            throw;
        }
    }
}
