using System;

namespace WebMailLite
{
	public enum SupportedDatabase
	{
		MsSqlServer = 1,
		MsAccess = 2,
		MySql = 3
	}

	public enum IncomingMailProtocol
	{
		Pop3 = 0,
		Imap4 = 1,
		WMServer = 2
	}

	public enum DefaultOrder
	{
		DateDesc = 0,
		Date = 1,
		FromDesc = 2,
		From = 3,
		ToDesc = 4,
		To = 5,
		SizeDesc = 6,
		Size = 7,
		SubjDesc = 8,
		Subj = 9,
		AttachmentDesc = 10,
        Attachment = 11,
		FlagDesc = 12,
		Flag = 13
	}

	[Flags]
	public enum MailMode
	{
		DeleteMessagesFromServer = 0,
		LeaveMessagesOnServer = 1,
		KeepMessagesOnServer = 2,
		DeleteMessageWhenItsRemovedFromTrash = 4
	}

	public enum SignatureType
	{
		Plain = 0,
		Html = 1
	}

	[Flags]
	public enum SignatureOptions
	{
		DontAddSignature = 0,
		AddSignatureToAllOutgoingMessages = 1,
		DontAddSignatureToRepliesAndForwards = 2
	}

//	[Flags]
//	public enum WebMailMessageFlags
//	{
//		None = 0,
//		Seen = 1,
//		Answered = 2,
//		Flagged = 4,
//		Deleted = 8,
//		Draft = 16,
//		Recent = 32,
//		Forwarded = 256,
//		MarkAsGrey = 512
//	}

	public enum FolderType
	{
		Inbox = 1,
		SentItems = 2,
		Drafts = 3,
		Trash = 4,
		Custom = 10
	}

	public enum FolderSyncType
	{
		DontSync = 0,
		NewHeadersOnly = 1,
		AllHeadersOnly = 2,
		NewEntireMessages = 3,
		AllEntireMessages = 4,
		DirectMode = 5
	}

	public enum FilterField
	{
		From = 0,
		To = 1,
		Subject = 2
	}

	public enum FilterCondition
	{
		ContainSubstring = 0,
		ContainExactPhrase = 1,
		NotContainSubstring = 2
	}

	public enum FilterAction
	{
		DoNothing = 0,
		DeleteFromServerImmediately = 1,
		MarkGrey = 2,
		MoveToFolder = 3
	}

	[Flags]
	public enum MessageMode
	{
		None = 0,
        Headers = 1,
		HtmlBody = 2,
		PlainBody = 4,
		HtmlReply = 8,
		PlainReply = 16,
        HtmlForward = 32,
		PlainForward = 64,
		FullHeaders = 128,
		Attachments = 256
	}

	public enum LoginMode
	{
		Default = 0, // (show all)
		HideLoginFieldLoginIsAccount = 10, // hide login field, login is account name from email
		HideLoginFieldLoginIsEmail = 11,
		HideEmailField = 20, // hide email field, email as "login + '@' + DefaultDomainOptional"
		HideEmailFieldDisplayDomainAfterLogin = 21,
		HideEmailFieldLoginIsLoginAndDomain = 22, // Login as concatenation of "Login" field + "@" + domain
		HideEmailFieldDisplayDomainAfterLoginAndLoginIsLoginAndDomain = 23 // Display domain after login field & Login as concatenation of "Login" field + "@" + domain		
	}

	[Flags]
	public enum ViewMode
	{
		WithoutPreviewPane = 0,
		WithPreviewPane = 1,
		AlwaysShowPictures = 2
	}
}
