﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.IO;
using System.Collections.Generic;
using System.Text;
using MailBee.ImapMail;

namespace WebMailLite
{
    public class WmServerFS
    {
        private string _email;
        private string _login;
        private string _domain;
        private string _maildirPath;
        private WebmailSettings _settings;

		public string MaildirPath
		{
			get { return _maildirPath; }
		}

		public WmServerFS(string email)
        {
            try
            {
                _email = email;
                string[] temp = _email.Split('@');
                _login = temp[0];
                _domain = temp[1];

                _settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
                _maildirPath = Path.Combine(_settings.WmServerRootPath, @"domains\" + _domain + @"\" + _login + @"\Maildir");
            }
            catch { }
        }

        #region Messages

        public void MoveMessagesFromNewToCur()
        {
			string NewPath = Path.Combine(_maildirPath, Constants.MailDirStruct.New);
			string CurPath = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);

            if (Directory.Exists(NewPath) && Directory.Exists(CurPath))
            {
                DirectoryInfo dir = new DirectoryInfo(NewPath);
                FileInfo[] fileInfos = dir.GetFiles();
                foreach (FileInfo fi in fileInfos)
                {
                    if (File.Exists(NewPath + @"\" + fi.Name) && !File.Exists(CurPath + @"\" + fi.Name))
                    {
                        File.Move(NewPath + @"\" + fi.Name, CurPath + @"\" + fi.Name);
                    }
                }
            }
        }

		public FileInfo[] GetMessagesFileInfo()
		{
			string path = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);
			DirectoryInfo dir = new DirectoryInfo(path);
			FileInfo[] fis = dir.GetFiles();
			return fis;
		}

		public string GetMessagePath(string uid)
		{
			string path = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);
			return Path.Combine(path, uid);
		}

		public void DeleteMessages(string[] messageUidSet)
		{
			string path = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);
			for (int i = 0; messageUidSet.Length > i; i++)
			{
				string msgPath = Path.Combine(path, messageUidSet[i]);
				if (File.Exists(msgPath))
				{
					File.Delete(msgPath);
				}
			}
		}

		public long GetMailStorageSize()
		{
			string path = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);
			if (Directory.Exists(path))
			{
				DirectoryInfo dir = new DirectoryInfo(path);
				FileInfo[] fileInfos = dir.GetFiles();
				long size = 0;
				foreach (FileInfo fi in fileInfos)
				{
					size += fi.Length;
				}
				return size;
			}
			return 0;
		}

		public int GetMessageCount()
		{
			string path = Path.Combine(_maildirPath, Constants.MailDirStruct.Cur);
			if (Directory.Exists(path))
			{
				DirectoryInfo dir = new DirectoryInfo(path);
				return dir.GetFiles().Length;
			}
			return 0;
		}

        #endregion
    }


}
