using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using WebMailLite.classic;
using MailBee.Mime;
using System.IO;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for basewebmail.
	/// </summary>
	public class basewebmail : System.Web.UI.Page
	{
		protected WebMailLite.classic.jsbuilder js = new WebMailLite.classic.jsbuilder();
		protected WebmailResourceManager _resMan = null;
		protected int _inboxMessageCount = 0;
		protected long _inboxSize = 0;

		protected System.Web.UI.WebControls.PlaceHolder PlaceHolderToolbar;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolder;
		protected System.Web.UI.WebControls.PlaceHolder PlaceHolderCopyright;

		protected System.Web.UI.WebControls.LinkButton PostBackButton;
		protected System.Web.UI.WebControls.LinkButton PagerButton;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HFAction;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HFRequest;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HFValue;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HFPageInfo;

		protected WebMailLite.classic.Inbox Control_Maillist;
		protected WebMailLite.classic.Toolbar Control_Toolbar;
		protected WebMailLite.Copyright Control_Copyright;
		protected Account acct = null;

		protected string defaultSkin = Constants.defaultSkinName;
		protected string defaultTitle = null;

		protected string uid;
		protected int charset;
		protected MessageAction Action;

		protected _Default ctrlDefault;
		protected NewMessage ctrlNewMessage;
		protected ViewMessage ctrlViewMessage;
		protected string strBodyOnClick = String.Empty;
		protected string AcctList = String.Empty;
		protected string delimeter = "";

		private void Page_Load(object sender, System.EventArgs e)
		{
			_resMan = (new WebmailResourceManagerCreator()).CreateResourceManager();
			acct = Session[Constants.sessionAccount] as Account;
			if (acct != null)
			{
				try
				{
					WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();

					delimeter = Utils.GetDelimeter();

					defaultSkin = settings.DefaultSkin;
					defaultTitle = settings.SiteName;
					
					SwitchScreen();

					Control_Toolbar.js = js;

					js.AddText(@"
	function GetServerElementByID(name)
	{
		var length = document.all.length;
		for (var i = 0; i < length; i++)
		{
			var elem = document.all[i];
			if (elem.id.toLowerCase().lastIndexOf(name.toLowerCase()) > 0)
			{
				return elem;
			}
		}
	}
");
					this.DataBind();

					return;
				}
				catch (Exception ex)
				{
					((basewebmail)this.Page).OutputException(ex);
				}
			}
			else
			{
				Response.Redirect("default.aspx?error=1");
			}
		}

		protected void LoadSession()
		{
		}

		protected void SaveSession()
		{
		}

		//The given function checks type of the screen
		protected void SwitchScreen()
		{
			LoadSession();
			string screen = null;
			if(Request.QueryString.Get("scr") != null)
			{
				screen = Request.QueryString.Get("scr").ToLower();
			}

			switch (screen)
			{
				case "new_message":
                    ShowNewMessage(true);
                    break;
                case "reply_message":
				case "replyall_message":
				case "forward_message":
					ShowNewMessage(false);
					break;
				case "view_message":
					ShowViewMessage();
					break;
				default:
					//defaut screen
					ShowDefault();
					break;
			}
			strBodyOnClick = "PopupMenu.checkShownItems();";
		}

		protected void ShowViewMessage()
		{
			string uid = "";
			int charset = -1;

			if(!IsPostBack)
			{
				uid = (string)Session["uid"];
				charset = (int)Session["charset"];
			}
			else
			{
				string[] arrTempMail = Regex.Split(HFValue.Value, "----");

				if(arrTempMail.Length > 1)
				{
					uid = arrTempMail[0];
					charset = Convert.ToInt32(arrTempMail[1]);
				}
				else
				{
					uid = "-1000";
					charset = 0;
				}
			}

			if(uid != "-1000")
			{
				PlaceHolderToolbar.Visible = true;

				ctrlViewMessage = LoadControl(@"classic\ViewMessage.ascx") as ViewMessage;
				if (ctrlViewMessage != null)
				{
					ctrlViewMessage.ID = "newViewMessage";
					ctrlViewMessage.Skin = defaultSkin;
					ctrlViewMessage.js = js;

					ctrlViewMessage.uid = uid;
					ctrlViewMessage.charset = charset;

					PlaceHolder.Controls.Add(ctrlViewMessage);
				}

				PlaceHolderCopyright.Visible = false;

				HFValue.Value = uid + "----" + charset;
			}
		}

		protected void ShowDefault()
		{
			WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();

			try
			{
				js.AddText("var messageWithAttach = false;");

				PlaceHolderToolbar.Visible = true;

				ctrlDefault = LoadControl(@"classic\default.ascx") as _Default;
				if (ctrlDefault != null)
				{
					ctrlDefault.ID = "DefaultID"; 
					ctrlDefault.Skin = defaultSkin;
					ctrlDefault.js = js;
					PlaceHolder.Controls.Add(ctrlDefault);
				}

				PlaceHolderCopyright.Visible = true;
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		protected void ShowNewMessage(bool isNew)
		{
			PlaceHolderToolbar.Visible = true;

			ctrlNewMessage = LoadControl(@"classic\newmessage.ascx") as NewMessage;
			if (ctrlNewMessage != null)
			{
				ctrlNewMessage.ID = "newMessageID";
				ctrlNewMessage.Skin = defaultSkin;
				ctrlNewMessage.js = js;
                if (Session["Action"] != null && !isNew)
                {
                    Action = (MessageAction)Session["Action"];
                    if (Action != MessageAction.New)
                    {
                        if (Session["uid"] != null) uid = (string)Session["uid"];
                        if (Session["charset"] != null) charset = (int)Session["charset"];
                        BaseWebMailActions actions = new BaseWebMailActions(acct, this.Page);
                        if (actions != null)
                        {
                            MailMessage msg = actions.GetMessage(uid, charset);
                            if (msg != null)
                            {
                                msg.BodyPlainText = msg.BodyPlainText.Replace("<br>", " ");
                                msg.BodyPlainText = Utils.RemoveATag(msg.BodyPlainText);

                                ctrlNewMessage.Message = msg;
                            }
                        }
                        ctrlNewMessage.Action = Action;
                    }
                }
                else
                {
                    ctrlNewMessage.Action = MessageAction.New;
                }
				PlaceHolder.Controls.Add(ctrlNewMessage);
			}

			PlaceHolderCopyright.Visible = true;
		}

		protected void ShowMessage()
		{
			_Default ctrlDefault = LoadControl(@"classic\Default.ascx") as _Default;
			if (ctrlDefault != null)
			{
				ctrlDefault.ID = "DefaultID";
				ctrlDefault.Skin = defaultSkin;
				ctrlDefault.js = js;
				PlaceHolder.Controls.Add(ctrlDefault);
			}

			PlaceHolderCopyright.Visible = false;
		}


		private void PostBackButton_Click(object sender, EventArgs e)
		{
			if(HFAction.Value != null && HFRequest.Value != null)
			{
				CheckAction(HFAction.Value.ToLower(), HFRequest.Value.ToLower());
			}
			else
			{
				if(HFValue.Value != null)
				{
//					Control_Maillist.PageNumber = Convert.ToInt32(HFValue.Value);
				}
			}
		}

		protected void CheckAction(string action, string request)
		{
			switch (action)
			{
				case "get":
					switch(request)
					{
						case "settings_list":
							break;
						case "messages":
							GetMessages();
							break;
						case "message":
							GetMessage();
							break;
						case "message_full_screen":
							GetMessageFullScreen();
							break;
					}
					break;
				case "update":
					break;
				case "send":
					SendMsg();
					break;
				case "operation_messages":
					switch(request)
					{
						case "delete":
							Delete();
							break;
					}
					break;
				case "delete":
					switch(request)
					{
						case "message":
							DeleteMessage();
							break;
					}
					break;
				case "reply":
					Reply();
					break;
				case "replyall":
					ReplyAll();
					break;
				case "forward":
					Forward();
					break;
				case "switch":
					switch(request)
					{
						case "html":
							SwitchToHtml();
							break;
						case "plain":
							SwitchToPlain();
							break;
					}
					break;
			}
		}

		protected void SwitchToHtml()
		{
		}

		protected void SwitchToPlain()
		{
		}

		protected void GetMessageFullScreen()
		{
			string[] arrTemp = Regex.Split(HFValue.Value, "----");
			uid = arrTemp[0];
			charset = Convert.ToInt32(arrTemp[1]);

			Session.Add("uid", uid);
			Session.Add("charset", charset);

			Response.Redirect("basewebmail.aspx?scr=view_message");
		}

		protected void Reply()
		{
			string[] arrTemp = Regex.Split(HFValue.Value, "----");
			uid = arrTemp[0];
			charset = Convert.ToInt32(arrTemp[1]);
			Action = MessageAction.Reply;

			Session.Add("uid", uid);
			Session.Add("charset", charset);
			Session.Add("Action", Action);

			Response.Redirect("basewebmail.aspx?scr=reply_message");
		}

		protected void ReplyAll()
		{
			string[] arrTemp = Regex.Split(HFValue.Value, "----");
			uid = arrTemp[0];
			charset = Convert.ToInt32(arrTemp[1]);
			Action = MessageAction.ReplyAll;

			Session.Add("uid", uid);
			Session.Add("charset", charset);
			Session.Add("Action", Action);

			Response.Redirect("basewebmail.aspx?scr=replyall_message");
		}

		protected void Forward()
		{
			string[] arrTemp = Regex.Split(HFValue.Value, "----");
			uid = arrTemp[0];
			charset = Convert.ToInt32(arrTemp[1]);
			Action = MessageAction.Forward;

			Session.Add("uid", uid);
			Session.Add("charset", charset);
			Session.Add("Action", Action);

			Response.Redirect("basewebmail.aspx?scr=forward_message");
		}

		protected void Delete()
		{
			try
			{
				LoadSession();

				string[] arrTemp = Regex.Split(HFValue.Value, "@#%");
				string[] arrTempMail  = new string[arrTemp.Length];

				for(int i = 0; arrTemp.Length > i; i++)
				{
					string[] msgID = Regex.Split(arrTemp[i], "----");
					arrTempMail[i] = msgID[0];
				}

				BaseWebMailActions bwml = new BaseWebMailActions(acct, this.Page);
				bwml.DeleteMessages(arrTempMail);

				ctrlDefault.Control_Maillist.OutputMessagesList();
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}


		protected void DeleteMessage()
		{
			try
			{
				LoadSession();

				string[] arrTempMail = Regex.Split(HFValue.Value, "----");

				BaseWebMailActions bwml = new BaseWebMailActions(acct, this.Page);
				bwml.DeleteMessages(arrTempMail);

				Response.Redirect("basewebmail.aspx?scr=default");
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		protected void SendMsg()
		{
            BaseWebMailActions bwml = new BaseWebMailActions(acct, this.Page);
            WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
			try
			{
				int id_msg = Convert.ToInt32(Request.Form["id_message"]);

                string From = Request.Form[ctrlNewMessage.FindControl("fromTextBox").UniqueID.ToString()];
                string To = Request.Form[ctrlNewMessage.FindControl("toTextBox").UniqueID.ToString()];
                string Cc = Request.Form[ctrlNewMessage.FindControl("ccTextBox").UniqueID.ToString()];
                string Bcc = Request.Form[ctrlNewMessage.FindControl("bccTextBox").UniqueID.ToString()];
                string Subject = Request.Form[ctrlNewMessage.FindControl("subjectTextBox").UniqueID.ToString()];
				string Priority = Request.Form["priority_input"];
				string AttachmentTempName = null;
				string AttachmentName = null;
				DateTime Date = DateTime.Now;
				string Charset = Utils.GetEncodingByCodePage(settings.DefaultUserCharset).HeaderName;

				bool IsHTML = (Request.Form["ishtml"] == "1");

				string Text = Request.Form["message"];

				MailMessage msg = new MailMessage();
			
				msg.From = EmailAddress.Parse(From);
				msg.To = EmailAddressCollection.Parse(To);
				msg.Cc = EmailAddressCollection.Parse(Cc);
				msg.Bcc = EmailAddressCollection.Parse(Bcc);
                msg.Subject = Subject;
				msg.Date = Date;
				msg.Charset = Charset;

				switch(Priority)
				{
					case "Low":
						msg.Priority = MailPriority.Low;
						break;
					case "Normal":
						msg.Priority = MailPriority.Normal;
						break;
					case "High":
						msg.Priority = MailPriority.High;
						break;
					default:
						msg.Priority = MailPriority.Normal;
						break;
				}

				for(int i = 0; Request.Form.AllKeys.Length > i; i++)
				{
					if(Request.Form.AllKeys[i].StartsWith("attachments["))
					{
						AttachmentName = Request.Form[Request.Form.AllKeys[i]];

						string[] temp = Regex.Split(Request.Form.AllKeys[i], Regex.Escape("["));
						AttachmentTempName = temp[1];
						temp = Regex.Split(AttachmentTempName, Regex.Escape("]"));
						AttachmentTempName = temp[0];
						AttachmentTempName = Path.Combine(Utils.GetTempFolderName(this.Session), AttachmentTempName);

						msg.Attachments.Add(AttachmentTempName, AttachmentName);
					}
				}

				if(IsHTML)
				{
					msg.BodyHtmlText = Text;
				}
				else
				{
					msg.BodyPlainText = Text;
				}

                bwml.SendMessage(msg);

                Session[Constants.sessionReportText] = _resMan.GetString("ReportMessageSent");

				Response.Redirect("basewebmail.aspx");
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		protected void GetMessage()
		{
			/*ctrlDefault.Control_Messagecontainer.isPreviewPane = true;
			string[] arrTemp = Regex.Split(HFValue.Value, "----");
			ctrlDefault.Control_Messagecontainer.uid = arrTemp[0];
			ctrlDefault.Control_Messagecontainer.charset = Convert.ToInt32(arrTemp[arrTemp.Length-1]);
			ctrlDefault.Control_Messagecontainer.Data_Bind(acct, 0);
			ctrlDefault.Control_Maillist.OutputMessagesList();

			string text = @"if(InboxLines) InboxLines.CheckLine(""" + HFValue.Value + @""");";
			
			js.AddInitText(text);*/
		}

		protected void GetMessages()
		{
			//TODO: get messages
			try
			{
//				BaseWebMailActions actions = new BaseWebMailActions(acct, this.Page);
//				ctrlDefault.Control_Maillist.Messages = actions.GetMessages(page, out _inboxMessageCount, out _inboxSize);

				LoadSession();
				string[] tempArr = Regex.Split(HFValue.Value, "----");

				SaveSession();

				Control_Toolbar.LoadButtons();
				ctrlDefault.Control_Maillist.OutputMessagesList();
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
		}

		private void PagerButton_Click(object sender, EventArgs e)
		{
			//LoadSession();
			string[] arrTemp = Regex.Split(HFPageInfo.Value, "----");
			if(arrTemp[0] == "m")
			{
				ctrlDefault.Control_Maillist.PageNumber = Convert.ToInt32(arrTemp[1]);
				ctrlDefault.Control_Maillist.OutputMessagesList();
			}
		}

		public void OutputException(Exception ex)
		{
			Log.WriteException(ex);

			js.AddText(@"
function CInformation(cont, cls)
{
	this._mainContainer = cont;
	this._containerClass = cls;
}

CInformation.prototype = {
	Show: function ()
	{
		this._mainContainer.className = this._containerClass;
	},
	
	Hide: function ()
	{
		this._mainContainer.className = 'wm_hide';
	},

	Resize: function ()
	{
		var tbl = this._mainContainer;
		tbl.style.width = 'auto';
		var offsetWidth = tbl.offsetWidth;
		var width = GetWidth();
		if (offsetWidth >  0.4 * width) {
			tbl.style.width = '40%';
			offsetWidth = tbl.offsetWidth;
		}
		tbl.style.left = (width - offsetWidth) + 'px';
		tbl.style.top = this.GetScrollY() + 'px';
	},

	GetScrollY: function()
	{
		var scrollY = 0;
		if (document.body && typeof document.body.scrollTop != ""undefined"")
		{
			scrollY += document.body.scrollTop;
			if (scrollY == 0 && document.body.parentNode && typeof document.body.parentNode != ""undefined"")
			{
				scrollY += document.body.parentNode.scrollTop;
			}
		} else if (typeof window.pageXOffset != ""undefined"")  {
			scrollY += window.pageYOffset;
		}
		return scrollY;
	}
}
");

			js.AddInitText(@"
objInfo = document.getElementById(""info"");
objInfoText = document.getElementById(""info_message"");

objInfoText.innerHTML = """ + ex.Message + @""";

Info = new CInformation(objInfo, ""wm_error_information"");
Info.Show();
Info.Resize();	

setTimeout(""Info.Hide();"", 20000);
");

		}

		public void OutputReport()
		{
			if ((Session[Constants.sessionReportText] != null) && (Session[Constants.sessionReportText].ToString().Length > 0))
			{
				js.AddText("var Report;");
				js.AddInitText(@"
Report = new CReport('Report');
Report.Build();
");
				js.AddInitText(string.Format(@"Report.Show('{0}');",
					Utils.EncodeJsSaveString((string)Session[Constants.sessionReportText])));
				Session[Constants.sessionReportText] = null;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new EventHandler(basewebmail_PreRender);
			PostBackButton.Click +=new EventHandler(PostBackButton_Click);
			PagerButton.Click +=new EventHandler(PagerButton_Click);
		}
		#endregion

		private void basewebmail_PreRender(object sender, EventArgs e)
		{
			OutputReport();
		}
	}
}