/*
Classes:
	CVerticalResizer
	CHorizontalResizer
	CSearchForm
*/

function CSearchForm(BigSearchForm, SmallSearchForm, SearchControl, SearchControlImg, bigFormId, bigLookFor, smallLookFor, skinName)
{
	this.form = BigSearchForm;
	this._bigFormId = bigFormId;
	this.small_form = SmallSearchForm;
	this.control = SearchControl;
	this.control_img = SearchControlImg;
	this.isShown = 0;
	this._bigLookFor = bigLookFor;
	this._smallLookFor = smallLookFor;
	this.shown = false;
	this._skinName = skinName;
}


CSearchForm.prototype = 
{
	Show: function ()
	{
		if (!this.shown) {
			this.shown = true;
			this.small_form.className = 'wm_toolbar_search_item';
			this.control.className = 'wm_toolbar_search_item';
			var obj = this;
			this.control.onclick = function() {
				obj.ShowBigForm();
			}
			this.control.onmouseover = function() {
				obj.control.className = 'wm_toolbar_search_item_over';
				obj.small_form.className = 'wm_toolbar_search_item_over';
			}
			this.control.onmouseout = function() {
				obj.control.className = 'wm_toolbar_search_item';
				obj.small_form.className = 'wm_toolbar_search_item';
			}
		}
	},
	
	Hide: function ()
	{
		this.shown = false;
		this.small_form.className = 'wm_hide';
		this.control.className = 'wm_hide';
		this.form.className = 'wm_hide';
	},
	
	ShowBigForm: function()
	{
		var bounds = GetBounds(this.small_form);
		this.form.style.top = bounds.Top + 'px';
		this.form.style.right = (GetWidth() - bounds.Left - bounds.Width) + 'px';
		this.form.className = 'wm_search_form';
		this.control.onclick = function() {}
		this.control_img.src = 'skins/' + this._skinName + '/menu/arrow_up.gif';
		this.isShown = 2;
		this._bigLookFor.value = this._smallLookFor.value;
	},
	
	HideBigForm: function()
	{
		this.form.className = 'wm_hide';
		var obj = this;
		this.control.onclick = function() {
			obj.ShowBigForm();
		}
		this.control_img.src = 'skins/' + this._skinName + '/menu/arrow_down.gif';
		this.isShown = 0;
		this._smallLookFor.value = this._bigLookFor.value;
	},
	
	checkVisibility: function(ev, isM)
	{
		if (this.isShown == 1) {
			var ev = ev ? ev : window.event;
			if (isM) {elem = ev.target;}
			else {elem = ev.srcElement;}
			while(elem && elem.tagName != 'DIV')
			{
				if(elem.parentNode) {elem = elem.parentNode;}
				else {break;}
			}
			if (elem.id != this._bigFormId) {this.HideBigForm();}
		}
		if (this.isShown == 2)
			this.isShown = 1;
	}
}