using System.Globalization;
using MailBee.Mime;

namespace WebMailLite.classic
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Text.RegularExpressions;

	/// <summary>
	///		Summary description for Inbox.
	/// </summary>
	public class Inbox : System.Web.UI.UserControl
	{
		protected WebmailResourceManager _manager = null;
		protected string _skin = Constants.defaultSkinName;
		protected int _page_number = 1;
		protected int _inboxMessageCount = 0;
		protected long _inboxSize = 0;
		protected System.Web.UI.WebControls.Literal LiteralList;
		protected System.Web.UI.WebControls.Literal LiteralCheck;
//		protected string _mailId = null;
		protected Account _acct = null;
		protected WebmailSettings _sett = null;
		protected MailMessageCollection _messages = null;
		protected bool _isWithPreview = false;

//		public string MailId
//		{
//			get { return _mailId; }
//			set { _mailId = value; }
//		}

		protected jsbuilder _js;
		public jsbuilder JSBuilder
		{
			get { return _js; }
			set { _js = value; }
		}

		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		public MailMessageCollection Messages
		{
			get { return _messages; }
			set { _messages = value; }
		}


		public int PageNumber
		{
			get { return _page_number; }
			set
			{
				_page_number = value;
				if (Session["page"] == null)
					Session.Add("page", _page_number);
				else
					Session["page"] = _page_number;
			}
		}


		public int InboxMessageCount
		{
			get { return _inboxMessageCount; }
			set { _inboxMessageCount = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();
			_acct = Session[Constants.sessionAccount] as Account;

			_sett = (new WebMailSettingsCreator()).CreateWebMailSettings();
			
			_isWithPreview = false;

			if (!_isWithPreview)
			{
				LiteralCheck.Text = @"<input type=""checkbox"" id=""allcheck"" onclick=""InboxLines.CheckAllbox(this)"" />";
			}

			if (_acct != null)
			{
				if(!IsPostBack)
				{
					OutputMessagesList();
				}
				
				_js.AddInitText(@"
InboxLines = new CSelection('"+ _sett.DefaultSkin + @"');
if(InboxLines) InboxLines.Fill();
");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		public void OutputMessagesList()
		{
			_page_number = (Session["page"] != null) ? Convert.ToInt32(Session["page"]) : 1;

			WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();
			string emptyListStr = _manager.GetString("InfoEmptyFolder");
			string messageListContent = string.Format(@"<tr><td style=""width: 404px;"" colspan=""6""/><td id=""subject"" style=""width: 150px;""/></tr><tr><td colspan=""7""><div class=""wm_inbox_info_message"">{0}</div></td></tr>", emptyListStr);
			try
			{
				messageListContent = string.Empty;

				BaseWebMailActions bwa = new BaseWebMailActions(_acct, this.Page);
				_messages = bwa.GetMessages(_page_number, out _inboxMessageCount, out _inboxSize);

				_Default defCtrl = this.Parent as _Default;
				if (defCtrl != null)
				{
					defCtrl.Control_LowToolbar.InboxMessageCount = _inboxMessageCount;
					defCtrl.Control_LowToolbar.InboxSize = _inboxSize;
				}

				System.Web.UI.HtmlControls.HtmlInputHidden HFPageInfo = (System.Web.UI.HtmlControls.HtmlInputHidden)  this.Page.FindControl("HFPageInfo");
				HFPageInfo.Value = _page_number + "----" + settings.MailsPerPage + "----" + _inboxMessageCount;

				if(_messages != null)
				{
					for (int i = 0; i < _messages.Count; i++)
					{
						MailMessage webMsg = _messages[i];
						messageListContent += OutputWebMailMessage(webMsg, (i == 0));
					}

//					LiteralList.Text = "<table id=\"list\">" + messageListContent + "</table>";

				}
//				else
//				{
//					string emptyListStr = (IsSearch) ? _manager.GetString("InfoNoMessagesFound") : _manager.GetString("InfoEmptyFolder");
//					messageListContent = string.Format(@"<tr><td style=""width: 404px;"" colspan=""6""/><td id=""subject"" style=""width: 150px;""/></tr><tr><td colspan=""7""><div class=""wm_inbox_info_message"">{0}</div></td></tr>", emptyListStr);
//					//LiteralList.Text = string.Format(@"<table id=""list""><tr><td style=""width: 404px;"" colspan=""6""/><td id=""subject"" style=""width: 150px;""/></tr><tr><td colspan=""7""><div class=""wm_inbox_info_message"">{0}</div></td></tr></table>", emptyListStr);
//				}
			}
			catch (Exception ex)
			{
				((basewebmail)this.Page).OutputException(ex);
			}
			finally
			{
				LiteralList.Text = @"<table id=""list"">" + messageListContent + "</table>";
			}
		}

		protected string OutputWebMailMessage(MailMessage webMsg, bool firstMessage)
		{
			
			string attachStr = string.Empty;
			if (webMsg.HasAttachments) attachStr = string.Format(@"<img src=""skins/{0}/menu/attachment.gif"">", _skin);

			string toFromStr = string.Empty;
			toFromStr = Server.HtmlEncode((webMsg.From.DisplayName != "") ? webMsg.From.DisplayName: webMsg.From.ToString());

			string uid = (_acct.MailProtocol != IncomingMailProtocol.WMServer) ? webMsg.UidOnServer.ToString() : ((XMailMessage)webMsg).UidXMail;
			string msgID = string.Format(@"{0}----{1}",
				uid, // 0
				(webMsg.Parser.EncodingOverride != null) ? webMsg.Parser.EncodingOverride.CodePage : -1 // 1
				);

			string messageRow = string.Format(@"
			<tr id=""{0}"" onclick=""CheckThisLine(event, this);"" ondblclick=""CheckThisLineDb(event, this);"">
				<td{11} id=""none"">{13}</td>
				<td{6}>{1}</td>
				<td class=""wm_inbox_from_subject""{7}><nobr>{14}{2}{15}</nobr></td>
				<td{8}><nobr>{3}</nobr></td>
				<td{9}><nobr>{4}</nobr></td>
				<td class=""wm_inbox_from_subject""{10}{12}><nobr>{14}{5}{15}</nobr></td>
			</tr>
", 
				Utils.AttributeQuote(msgID), //0
				attachStr, // 1
				toFromStr, // 2
				Utils.GetDateWithOffsetFormatString(_acct, webMsg.DateReceived.ToUniversalTime()), // 3
				Utils.GetFriendlySize(webMsg.SizeOnServer), // 4
				Server.HtmlEncode(webMsg.Subject), // 5
                (firstMessage) ? @" style=""WIDTH: 20px""" : "", // 6
				(firstMessage) ? @" style=""WIDTH: 150px""" : "", // 7
				(firstMessage) ? @" style=""WIDTH: 140px""" : "", // 8
				(firstMessage) ? @" style=""WIDTH: 50px""" : "", // 9
				(firstMessage) ? @" style=""WIDTH: 150px""" : "", // 10
				(firstMessage) ? @" style=""WIDTH: 24px""" : "", // 11
				(firstMessage) ? @" id=""subject""" : "", // 12
				(_isWithPreview) ? "" : @"<input type=""checkbox"" />", // 13
				(_isWithPreview) ? "" : @"<a href=""#"">", // 14
				(_isWithPreview) ? "" : "</a>" // 15
				);

			return messageRow;
		}
	}
}
